codechef Heavy-light Decompositions
Heavy-light Decompositions Problem Code: HLDOTSSubmit
Heavy-light decomposition of a tree is a powerful tool that often helps in the most difficult tree data structure problems.
Heavy-light decomposition is to be built on a rooted tree. In this problem, the node with the number 1 should be considered the root of a tree. Heavy light decomposition is a colouring of edges of the tree. Each edge is either heavy or light. For each non leaf node (node having degree greater than 1), from all the edges emanating from it into the subtree rooted at this vertex should have exactly one heavy edge.
The heavy-light decomposition is called correct, if you can reach any node from the root node by using no more that ⌊ log2 N ⌋ light edges, where N is the number of nodes in the tree.
Given a tree, calculate the number of its' correct heavy-light decompositions. As answer could be very large, please print it modulo 19101995.
Input
There is exactly one test case.
The first line of input consists of a single integer N, denoting the number of the nodes in the tree.
Each of the following N - 1 lines contains a pair of integers, denoting the numbers of the nodes that are connected with an edge. The nodes are enumerated by positive integers in the range [1; N].
Output
Output the number of correct heavy-light decompositions of the given tree. Since this number can be huge, please output it modulo 19101995.
Constraints
- (Subtask 1): 1 ≤ N ≤ 20 - 21 point.
- (Subtask 2): 1 ≤ N ≤ 1000 - 34 points.
- (Subtask 3): 1 ≤ N ≤ 100000 - 45 points.
Example
Input:
7
1 2
3 1
3 4
3 5
2 6
2 7 Output:
8
Explanation
Example case 1. Input is a complete binary tree. It consists of 7 nodes, therefore you can't have more than ⌊log2 7⌋ = ⌊(2.80735492206)⌋ = 2 light edges on the path from the root node to any other one. But the tree's height is 2, so you can choose the decomposition in any way you like. All the decompositions will be correct ones. There are three nodes that has outgoing edges from them (in the direction opposite to the root's one), their numbers are 1, 2 and 3. Each of them has 2 outgoing edges from which you can colour exactly one of them heavy, so overall you'll have 2 * 2 * 2 = 8 options of creating the correct heavy-light decompositions.
//Serene
#include<algorithm>
#include<iostream>
#include<cstring>
#include<cstdlib>
#include<cstdio>
#include<cmath>
using namespace std;
const long long maxn=1e5+10,mod=19101995;
long long n,f[maxn][20],g[maxn][20],ans[maxn][20],fa[maxn],sz,fr[2*maxn]; long long aa;char cc;
long long read() {
aa=0;cc=getchar();
while(cc<'0'||cc>'9') cc=getchar();
while(cc>='0'&&cc<='9') aa=aa*10+cc-'0',cc=getchar();
return aa;
} long long fir[maxn],nxt[2*maxn],to[2*maxn],e=0;
void add(long long x,long long y) {
to[++e]=y;nxt[e]=fir[x];fir[x]=e;
to[++e]=x;nxt[e]=fir[y];fir[y]=e;
} long long rs;
long long qp(long long x,long long k) {
rs=1;if(x<=1) return x;
while(k) {
if(k&1) (rs*=x)%=mod;
x=x*x%mod;k>>=1;
}
return rs;
} void dfs(long long pos) {
long long z,tt=0,tot;
for(long long y=fir[pos];y;y=nxt[y]) {
if((z=to[y])==fa[pos]) continue;
fa[z]=pos; dfs(z);
}
for(long long i=0;i<=sz;++i) f[0][i]=1ll;
for(long long y=fir[pos];y;fr[nxt[y]]=y,y=nxt[y]) {
if((z=to[y])==fa[pos]) continue; tt++;
for(long long i=0;i<=sz;++i) (f[tt][i]=f[tt-1][i]*ans[z][i])%=mod;
}
tot=tt;
for(long long i=0;i<=sz;++i) g[tt][i]=1ll;
fr[fir[pos]]=0;
for(long long y=fr[0];y;y=fr[y]) {
if((z=to[y])==fa[pos]) continue; tt--;
for(long long i=0;i<=sz;++i) (g[tt][i]=g[tt+1][i]*ans[z][i])%=mod;
}
if(tot>1) for(long long y=fir[pos];y;y=nxt[y]) {
if((z=to[y])==fa[pos]) continue; tt++;
for(long long i=1;i<=sz;++i) (ans[pos][i]+=f[tt-1][i-1]*g[tt][i-1]%mod*ans[z][i])%=mod;
}
else if(!tot)for(long long i=0;i<=sz;++i) ans[pos][i]=1;
else {
if(to[fr[0]]==fa[pos]) fr[0]=fr[fr[0]];
for(long long i=0;i<=sz;++i) ans[pos][i]=ans[to[fr[0]]][i];
}
} int main() {
n=read();long long x,y;
sz=(long long)((double)log(n)/(double)log(2)+1e-8);
for(long long i=1;i<n;++i) {
x=read();y=read();
add(x,y);
}
dfs(1);
printf("%lld",ans[1][sz]);
return 0;
}
/*
7
1 2
3 2
4 3
5 1
6 2
7 3 right answer:
6
*/
对拍的rand:
//Serene
#include<algorithm>
#include<iostream>
#include<cstring>
#include<cstdlib>
#include<cstdio>
#include<cmath>
#include<ctime>
using namespace std;
const int maxn=15;
int n; int main() {
srand((unsigned)time(NULL));
n=rand()%maxn+2;int x;
printf("%d\n1 2\n",n);
for(int i=3;i<=n;++i) {
x=rand()%(i-1)+1;
printf("%d %d\n",i,x);
}
return 0;
}
codechef Heavy-light Decompositions的更多相关文章
- Heavy Light Decomposition
Note 1.DFS1 mark all the depth mark fathers mark the heavy/light children mark the size of each subt ...
- 树链剖分I 原理
树链剖分(Heavy Light Decomposition, HLD)是一种将对[树上两点间的路径]上[边或点]的[修改与查询]转化到[序列]上来处理的方法. 目的:将树的边或点转化到一个线性结构( ...
- ACM/ICPC 之 拓扑排序-反向(POJ3687)
难点依旧是题意....需要反向构图+去重+看题 POJ3687-Labeling Balls 题意:1-N编号的球,输出满足给定约束的按原编号排列的重量序列,如果有多组答案,则输出编号最小的Ball重 ...
- poj1013
题目大意:假造的银币 Sally Jones有一些游客给的银币,但是只有11枚是真正的银币(有一枚是假的),从颜色和大小是无法区分真比还是假币的,但是它的重量和真币是不同的,Sally Jones它是 ...
- Java8 in action(1) 通过行为参数化传递代码--lambda代替策略模式
[TOC] 猪脚:以下内容参考<Java 8 in Action> 需求 果农需要筛选苹果,可能想要绿色的,也可能想要红色的,可能想要大苹果(>150g),也可能需要红的大苹果.基于 ...
- TCP与UDP区别小结
TCP(Transmission Control Protocol):传输控制协议 UDP(User Datagram Protocol):用户数据报协议 主要从连接性(Connectiv ...
- POJ1013 称硬币
题目链接:http://poj.org/problem?id=1013 题目大意 有12枚硬币.其中有11枚真币和1枚假币.假币和真币重量不同,但不知道假币比真币轻还是重.现在,用一架天平称了这些币三 ...
- 神奇的树上启发式合并 (dsu on tree)
参考资料 https://www.cnblogs.com/zhoushuyu/p/9069164.html https://www.cnblogs.com/candy99/p/dsuontree.ht ...
- HDU 5111 Alexandra and Two Trees 树链剖分 + 主席树
题意: 给出两棵树,每棵树的节点都有一个权值. 同一棵树上的节点的权值互不相同,不同树上节点的权值可以相同. 要求回答如下询问: \(u_1 \, v_1 \, u_2 \, v_2\):询问第一棵树 ...
随机推荐
- java udp协议DatagramSocket类使用
package com.temp; import org.junit.Test; import java.io.*; import java.net.DatagramPacket; import ja ...
- Leetcode105. Construct Binary Tree from Preorder and Inorder Traversal前序与中序构造二叉树
根据一棵树的前序遍历与中序遍历构造二叉树. 注意: 你可以假设树中没有重复的元素. 例如,给出 前序遍历 preorder = [3,9,20,15,7] 中序遍历 inorder = [9,3,15 ...
- Leetcode82. Remove Duplicates from Sorted List II删除排序链表中的重复元素2
给定一个排序链表,删除所有含有重复数字的节点,只保留原始链表中 没有重复出现 的数字. 示例 1: 输入: 1->2->3->3->4->4->5 输出: 1-&g ...
- bzoj 2935 [Poi1999]原始生物——欧拉回路思路!
题目:https://www.lydsy.com/JudgeOnline/problem.php?id=2935 有向图用最小的路径(==总点数最少)覆盖所有边. 完了完了我居然连1999年的题都做不 ...
- H5C3--边框阴影box-shadow
<!DOCTYPE html> <html lang="en"> <head> <meta charset="UTF-8&quo ...
- python 全局种子与局部种子
- 洛谷P1470 最长前缀
P1470 最长前缀 Longest Prefix 题目描述 在生物学中,一些生物的结构是用包含其要素的大写字母序列来表示的.生物学家对于把长的序列分解成较短的序列(即元素)很感兴趣. 如果一个集合 ...
- pycharm使用gitlab输错密码解决办法
在pycharm中使用http方式连接gitlab,在测试连接的时候提示输入用户名,密码.密码输错后,以后的每次test都是使用错误的密码,在删除pycharm后也是一样,解决方法是在控制面板\用户帐 ...
- 百分比宽度并排元素浮动之后,设置margin,padding换行的问题
今天遇到一个问题, 如下图,右边的div加了内边距换行: 解决方法: box-sizing: border-box;
- Vue Router 相关
1. 路由传参: 编程式的导航 router.push this.$router.push("home"); this.$router.push({ name: 'news', p ...